/**********************************
          GLOBAL VARIABLES
***********************************/
// pre-cache art files and sizes for widget styles and spacers
// (all images must have same height/width)
var collapsedWidget = new Image(20, 16);
collapsedWidget.src = "../Ru/image/menu/oplus.gif";
var collapsedWidgetStart = new Image(20, 16);
collapsedWidgetStart.src = "../Ru/image/menu/oplusStart.gif";
var collapsedWidgetEnd = new Image(20, 16);
collapsedWidgetEnd.src = "../Ru/image/menu/oplusEnd.gif";
var expandedWidget = new Image(20, 16);
expandedWidget.src = "../Ru/image/menu/ominus.gif";
var expandedWidgetStart = new Image(20, 16);
expandedWidgetStart.src = "../Ru/image/menu/ominusStart.gif";
var expandedWidgetEnd = new Image(20, 16);
expandedWidgetEnd.src = "../Ru/image/menu/ominusEnd.gif";
var nodeWidget = new Image(20, 16);
nodeWidget.src = "../Ru/image/menu/onode.gif";
var nodeWidgetEnd = new Image(20, 16);
nodeWidgetEnd.src = "../Ru/image/menu/onodeEnd.gif";
var emptySpace = new Image(20, 16);
emptySpace.src = "../Ru/image/menu/oempty.gif";
var chainSpace = new Image(20, 16);
chainSpace.src = "../Ru/image/menu/ochain.gif";

// miscellaneous globals
var widgetWidth = "26";
var widgetHeight = "20";
var currState = "";
var displayTarget = "contentFrame";

/**********************************
            
***********************************/
var expansionState = "";
// constructor for outline item objects
function outlineItem(text, uri) {
    this.text = text;
    this.uri = uri;
}
var olData = {childNodes:
             [{item:new outlineItem("General part", "main.html"),
               childNodes:
                   [{item:new outlineItem("Construction", "general.html")},
                    {item:new outlineItem("Agreement", "soglosh.html")},
                    {item:new outlineItem("Literature", "literatur.html")}
                    ]}, 
              {item:new outlineItem("Atlas", "skeleton.html"),
               childNodes:

                    [{item:new outlineItem("Humerus", "plech.html"),
                     childNodes:
							 [{item:new outlineItem("Level I", "p1.html")},
							  {item:new outlineItem("Level II", "p2.html")},
							  {item:new outlineItem("Level III", "p3.html")},
							  {item:new outlineItem("Level IV", "p4.html")},
							  {item:new outlineItem("Level V", "p5.html")},
							  {item:new outlineItem("Level VI", "p6.html")},
							  {item:new outlineItem("Level VII", "p7.html")},
							  {item:new outlineItem("Level VIII", "p8.html")}
							  ]},
						{item:new outlineItem("Forearm","predplech.html"),
						 childNodes:
								 [{item:new outlineItem("Pronation"),
								 childNodes:
									 [{item:new outlineItem("Ulna"),
									 	childNodes:
										 [{item:new outlineItem("Level I", "plp1.html")},
										  {item:new outlineItem("Level II", "plp2.html")},
										  {item:new outlineItem("Level III", "plp3.html")},
										  {item:new outlineItem("Level IV", "plp4.html")},
										  {item:new outlineItem("Level V", "plp5.html")},
										  {item:new outlineItem("Level VI", "plp6.html")},
										  {item:new outlineItem("Level VII", "plp7.html")},
										  {item:new outlineItem("Level VIII", "plp8.html")}
										 ]},
									  {item:new outlineItem("Radius"),
									 	childNodes:
										 [{item:new outlineItem("Level I", "plup1.html")},
										  {item:new outlineItem("Level II", "plup2.html")},
										  {item:new outlineItem("Level III", "plup3.html")},
										  {item:new outlineItem("Level IV", "plup4.html")},
										  {item:new outlineItem("Level V", "plup5.html")},
										  {item:new outlineItem("Level VI", "plup6.html")},
										  {item:new outlineItem("Level VII", "plup7.html")},
										  {item:new outlineItem("Level VIII", "plup8.html")}
										 ]}
									 ]},
								{item:new outlineItem("Middle"),
								childNodes:
									 [{item:new outlineItem("Ulna", "pred_lok.html"),
									 	childNodes:
										 [{item:new outlineItem("Level I", "pls1.html")},
										  {item:new outlineItem("Level II", "pls2.html")},
										  {item:new outlineItem("Level III", "pls3.html")},
										  {item:new outlineItem("Level IV", "pls4.html")},
										  {item:new outlineItem("Level V", "pls5.html")},
										  {item:new outlineItem("Level VI", "pls6.html")},
										  {item:new outlineItem("Level VII", "pls7.html")},
										  {item:new outlineItem("Level VIII", "pls8.html")}
										 ]},
									  {item:new outlineItem("Radius", "pred_luch.html"),
									 	childNodes:
										 [{item:new outlineItem("Level I", "plus1.html")},
										  {item:new outlineItem("Level II", "plus2.html")},
										  {item:new outlineItem("Level III", "plus3.html")},
										  {item:new outlineItem("Level IV", "plus4.html")},
										  {item:new outlineItem("Level V", "plus5.html")},
										  {item:new outlineItem("Level VI", "plus6.html")},
										  {item:new outlineItem("Level VII", "plus7.html")},
										  {item:new outlineItem("Level VIII", "plus8.html")}
										 ]}
										 ]},
								{item:new outlineItem("Supination"),
								childNodes:
									 [{item:new outlineItem("Ulna"),
									 	childNodes:
										 [{item:new outlineItem("Level I", "plsu1.html")},
										  {item:new outlineItem("Level II", "plsu2.html")},
										  {item:new outlineItem("Level III", "plsu3.html")},
										  {item:new outlineItem("Level IV", "plsu4.html")},
										  {item:new outlineItem("Level V", "plsu5.html")},
										  {item:new outlineItem("Level VI", "plsu6.html")},
										  {item:new outlineItem("Level VII", "plsu7.html")},
										  {item:new outlineItem("Level VIII", "plsu8.html")}
										 ]},
									  {item:new outlineItem("Radius"),
									 	childNodes:
										 [{item:new outlineItem("Level I", "plusu1.html")},
										  {item:new outlineItem("Level II", "plusu2.html")},
										  {item:new outlineItem("Level III", "plusu3.html")},
										  {item:new outlineItem("Level IV", "plusu4.html")},
										  {item:new outlineItem("Level V", "plusu5.html")},
										  {item:new outlineItem("Level VI", "plusu6.html")},
										  {item:new outlineItem("Level VII", "plusu7.html")},
										  {item:new outlineItem("Level VIII", "plusu8.html")}
										 ]}
										 ]}
								]				
							},		  
						{item:new outlineItem("Femur", "b_z.html"),
						 childNodes:
							 [{item:new outlineItem("Level I", "b1.html")},
							  {item:new outlineItem("Level II", "b2.html")},
							  {item:new outlineItem("Level III", "b3.html")},
							  {item:new outlineItem("Level IV", "b4.html")},
							  {item:new outlineItem("Level V", "b5.html")},
							  {item:new outlineItem("Level VI", "b6.html")},
							  {item:new outlineItem("Level VII", "b7.html")},
							  {item:new outlineItem("Level VIII", "b8.html")}
                          				]},
						{item:new outlineItem("Shin", "golen.html"),
						 childNodes:
								[{item:new outlineItem("Level I", "g1.html")},
								{item:new outlineItem("Level II", "g2.html")},
								{item:new outlineItem("Level III", "g3.html")},
								{item:new outlineItem("Level IV", "g4.html")},
								{item:new outlineItem("Level V", "g5.html")},
								{item:new outlineItem("Level VI", "g6.html")},
								{item:new outlineItem("Level VII", "g7.html")},
								{item:new outlineItem("Level VIII", "g8.html")}
                         ]}
                   ]}
                  ]
              };
          
          


/**********************************
     
***********************************/
// invert item state (expanded to/from collapsed)
function swapState(currState, currVal, n) {
    var newState = currState.substring(0,n);
    newState += currVal ^ 1 // Bitwise XOR item n;
    newState += currState.substring(n+1,currState.length);
    return newState;
}

// retrieve matching version of 'minus' images
function getExpandedWidgetState(imgURL) {
    if (imgURL.indexOf("Start") != -1) {
        return expandedWidgetStart.src;
    }
    if (imgURL.indexOf("End") != -1) {
        return expandedWidgetEnd.src;
    }
    return expandedWidget.src;
}

// retrieve matching version of 'plus' images
function getCollapsedWidgetState(imgURL) {
    if (imgURL.indexOf("Start") != -1) {
        return collapsedWidgetStart.src;
    }
    if (imgURL.indexOf("End") != -1) {
        return collapsedWidgetEnd.src;
    }
    return collapsedWidget.src;
}

// toggle an outline mother entry, storing new state value;
// invoked by onclick event handlers of widget image elements
function toggle(img, blockNum) {
    var newString = "";
    var expanded, n;
    // modify state string based on parameters from IMG
    expanded = currState.charAt(blockNum);
    currState = swapState(currState, expanded, blockNum);
    // dynamically change display style
    if (expanded == "0") {
        document.getElementById("OLBlock" + blockNum).style.display = "block";
        img.src = getExpandedWidgetState(img.src);
    } else {
        document.getElementById("OLBlock" + blockNum).style.display = "none";
        img.src = getCollapsedWidgetState(img.src);
    }
}

function expandAll() {
    var newState = "";
    while (newState.length < currState.length) {
        newState += "1";
    }
    currState = newState;
    initExpand();
}

function collapseAll() {
    var newState = "";
    while (newState.length < currState.length) {
        newState += "0";
    }
    currState = newState;
    initExpand();
}

/*********************************
           HTML
**********************************/
// apply default expansion state from outline's header
// info to the expanded state for one element to help 
// initialize currState variable
function calcBlockState(n) {
    // get default expansionState data
    var expandedData = (expansionState.length > 0) ? expansionState.split(",") : null;
    if (expandedData) {
        for (var j = 0; j < expandedData.length; j++) {
            if (n == expandedData[j] - 1) {
                return "1";
            }
        }
    }
    return "0";
}

// counters for reflexive calls to drawOutline()
var currID = 0;
var blockID = 0;
// generate HTML for outline
function drawOutline(ol, prefix) {
    var imsrc = "image\menu\\";
	var output = "";
    var nestCount, link, nestPrefix, lastInnerNode;
    prefix = (prefix) ? prefix : "";
    for (var i = 0; i < ol.childNodes.length ; i++) {
        nestCount = (ol.childNodes[i].childNodes) ? ol.childNodes[i].childNodes.length : 0;
        output += "<div class='OLRow' id='line" + currID++ + "'>\n";
        if (nestCount > 0) {
            output += prefix;
            output += "<img id='widget" + (currID-1) + "' src='" + ((i == ol.childNodes.length-1 && blockID != 0) ? collapsedWidgetEnd.src : (blockID == 0) ? collapsedWidgetStart.src : collapsedWidget.src);
            output += "' height=" + widgetHeight + " width=" + widgetWidth;
            output += " title='.' onClick='toggle(this," + blockID + ")'>";
            link =  (ol.childNodes[i].item.uri) ? ol.childNodes[i].item.uri : "";
            if (link) {
                output += "<a href='" + link + "' class='itemTitle' title='" + 
                link + "' target='" + displayTarget + "'>" ;
            } else {
                output += "<a class='itemTitle' title='" + link + "'>";
            }
            output += "<span style='position:relative; top:-3px; height:11px'>" + ol.childNodes[i].item.text + "</span></a>";
            currState += calcBlockState(currID-1);
            output += "<span class='OLBlock' blocknum='" + blockID + "' id='OLBlock" + blockID++ + "'>";
            nestPrefix = prefix;
            nestPrefix += (i == ol.childNodes.length - 1) ? 
                       "<img src='"+emptySpace.src + "' height=" + widgetHeight + " width=" + widgetWidth + ">" :
                       "<img src='"+chainSpace.src + "' height=" + widgetHeight + " width=" + widgetWidth + ">"
            output += drawOutline(ol.childNodes[i], nestPrefix);
            output += "</span></div>\n";
        } else {
            output += prefix;
            output += "<img id='widget" + (currID-1) + "' src='" + ((i == ol.childNodes.length - 1) ? nodeWidgetEnd.src : nodeWidget.src);
            output += "' height=" + widgetHeight + " width=" + widgetWidth + ">";
            link =  (ol.childNodes[i].item.uri) ? ol.childNodes[i].item.uri : "";
            if (link) {
                output += "&nbsp;<a href='" + link + "' class='itemTitle' title='" + 
                link + "' target='" + displayTarget + "'>";
            } else {
                output += "&nbsp;<a class='itemTitle' title='" + link + "'>";
            }
            output += "<span style='position:relative; top:-3px; height:11px'>" + ol.childNodes[i].item.text + "</span></a>";
            output += "</div>\n";
        }
    }
    return output;
}

/*********************************
           
**********************************/
// expand items set in expansionState var, if any
function initExpand() {
    for (var i = 0; i < currState.length; i++) {
        if (currState.charAt(i) == 1) {
            document.getElementById("OLBlock" + i).style.display = "block";
        } else {
            document.getElementById("OLBlock" + i).style.display = "none";
        }
    }
}

// initialize first time -- invoked onload
function initExpMenu(xFile) {
    // wrap whole outline HTML in a span
    var olHTML = "<span id='renderedOL'>" + drawOutline(olData) + "</span>";
    // throw HTML into 'content' div for display
    document.getElementById("content").innerHTML = olHTML;
    initExpand();
}
